
package net.mcreator.destroybedrock.block;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.world.storage.loot.LootContext;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.BlockItem;
import net.minecraft.block.material.Material;
import net.minecraft.block.SoundType;
import net.minecraft.block.BlockState;
import net.minecraft.block.Block;

import net.mcreator.destroybedrock.item.SlimeBacteriumItem;
import net.mcreator.destroybedrock.DestroyBedrockModElements;

import java.util.List;
import java.util.Collections;

@DestroyBedrockModElements.ModElement.Tag
public class MoldySpongeBlock extends DestroyBedrockModElements.ModElement {
	@ObjectHolder("destroy_bedrock:moldy_sponge")
	public static final Block block = null;
	public MoldySpongeBlock(DestroyBedrockModElements instance) {
		super(instance, 10);
	}

	@Override
	public void initElements() {
		elements.blocks.add(() -> new CustomBlock());
		elements.items
				.add(() -> new BlockItem(block, new Item.Properties().group(ItemGroup.BUILDING_BLOCKS)).setRegistryName(block.getRegistryName()));
	}
	public static class CustomBlock extends Block {
		public CustomBlock() {
			super(Block.Properties.create(Material.EARTH).sound(SoundType.PLANT).hardnessAndResistance(0.6000000000000001f, 0.6f).lightValue(0));
			setRegistryName("moldy_sponge");
		}

		@Override
		public List<ItemStack> getDrops(BlockState state, LootContext.Builder builder) {
			List<ItemStack> dropsOriginal = super.getDrops(state, builder);
			if (!dropsOriginal.isEmpty())
				return dropsOriginal;
			return Collections.singletonList(new ItemStack(SlimeBacteriumItem.block, (int) (1)));
		}
	}
}
